package dejux;

use strict;

my %clients = (
	dejux	=> {
		nick			=> 'dejux',
		ident			=> 'no',
		host			=> 'spam',
		ip				=> '0.0.0.0',
		cloak			=> 'spam',
		gecos			=> 'dejux',
		umode			=> '+Siopy',
		authflags	=> '$=^_><|',
		nickserv		=> 'password',
		chans			=> {
								'#acid'				=> '',
								'#projectproxy'	=> '+',
								'#a'					=> ''
							}
				}
);

my %dejux = (
	logchan		=> '#projectproxy',
	logfile		=> 'log/dejux.log',
	namesfile	=> 'mod/dejux.txt',
);

my %names;

open NAMES, '<', $dejux{namesfile};
for (<NAMES>) {
	chomp;
	$names{$_}++;
}
close NAMES;

sub new {
	my ($package, %self) = @_;
	my $self = bless(\%self, $package);

	acid::setupclients(%clients);

	my $uid = acid::getid($clients{dejux}{nick});

	acid::privmsg($uid, $self->{conf}{logchan}, 'Loaded %d unique names list entries from %s.', scalar(keys(%names)), $dejux{namesfile});

	return $self;
}

sub on_unload {
	my $self = shift;

	acid::removeclients(%clients);
}

sub on_uid {
	my ($self, $sid, $nick, $hops, $ts, $umode, $ident, $cloak, $ip, $uid, $host, $gecos) = @_;

	return if substr($ident, 0, 1) ne '~';
	my $user = substr($ident, 1);

	if ($names{$nick} && $names{$gecos} && (length($user) > 8 || $names{$user})) {
		return if $nick eq $user || $nick eq $gecos || $user eq $gecos;

		acid::capture($uid);

		my $myuid = acid::getid($clients{dejux}{nick});

		my $info = acid::getinfo($uid);
		acid::privmsg($myuid, $dejux{logchan}, 'MATCH: %s', $info);
		acid::privmsg($myuid, '#a', '~dadd %s 2 open proxy: %s!%s@%s:%s', $ip, $nick, $ident, $host, $gecos);

		unless (open LOG, '>>', $dejux{logfile}) {
			acid::privmsg($myuid, $dejux{logchan}, 'Failed to add %s entry for %s: %s', $dejux{logfile}, $nick, $!);
			return;
		}
		printf LOG "[%s] %s\n", scalar(localtime), $info;
		close LOG;
	}
}

1;
